## rocalution 7.1.0

=== CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2025 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

# Consider removing this in the future
# This should appear before the project command, because it does not use FORCE
if(WIN32)
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories")
else()
  set(CMAKE_INSTALL_PREFIX ${ROCM_PATH} CACHE PATH "Install path prefix, prepended onto install directories")
endif()

# Needed to pickup static library files
list(APPEND CMAKE_PREFIX_PATH ${ROCM_PATH}/llvm ${ROCM_PATH})

# CMake modules
list(APPEND CMAKE_MODULE_PATH
     ${CMAKE_CURRENT_SOURCE_DIR}/cmake
     ${ROCM_PATH}/lib/cmake/hip
     ${ROCM_PATH}/hip/cmake
     ${ROCM_PATH}/cmake)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Honor per-config flags in try_compile() source-file signature. cmake v3.7 and up
if(POLICY CMP0066)
  cmake_policy(SET CMP0066 NEW)
endif()

# rocALUTION project
project(rocalution LANGUAGES CXX)

# Build flags
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_HIP_STANDARD 17)
set(CMAKE_HIP_STANDARD_REQUIRED ON)
set(CMAKE_HIP_EXTENSIONS OFF)

# Build options
option(BUILD_SHARED_LIBS "Build rocALUTION as a shared library" ON)
option(BUILD_CLIENTS_TESTS "Build tests (requires googletest)" OFF)
option(BUILD_CLIENTS_BENCHMARKS "Build benchmarks (requires boost)" OFF)
option(BUILD_CLIENTS_SAMPLES "Build examples" ON)
option(BUILD_VERBOSE "Output additional build information" OFF)
option(BUILD_CODE_COVERAGE "Build with code coverage enabled" OFF)
option(BUILD_ADDRESS_SANITIZER "Build with address sanitizer enabled" OFF)
option(BUILD_GLOBALTYPE_64 "Support global number of rows / columns exceeding 32 bits" OFF)
option(BUILD_LOCALTYPE_64 "Support local number of rows / columns exceeding 32 bits" OFF)
option(BUILD_PTRTYPE_64 "Support local number of non-zeros exceeding 32 bits" OFF)
option(BUILD_OPTCPU "Enable all instruction subsets supported by the local machine" OFF)
option(BUILD_SUPPORT_COMPLEX "Enable complex number support" ON)

# Dependencies
include(cmake/Dependencies.cmake)

if(BUILD_ADDRESS_SANITIZER)
  set(DEFAULT_AMDGPU_TARGETS
    gfx908:xnack+
    gfx90a:xnack+
    gfx942:xnack+
  )
else()
  set(DEFAULT_AMDGPU_TARGETS
    gfx803
    gfx900:xnack-
    gfx906:xnack-
    gfx908:xnack-
    gfx90a:xnack-
    gfx90a:xnack+
    gfx942
    gfx950
    gfx1030
    gfx1100
    gfx1101
    gfx1102
    gfx1151
    gfx1200
    gfx1201
  )
endif()
if(AMDGPU_TARGETS AND NOT GPU_TARGETS)
  message( DEPRECATION "AMDGPU_TARGETS use is deprecated. Use GPU_TARGETS." )
endif()
set(AMDGPU_TARGETS "${DEFAULT_AMDGPU_TARGETS}" CACHE STRING "Target default GPUs if AMDGPU_TARGETS is not defined. (Deprecated, prefer GPU_TARGETS)")
# Don't force, users should be able to override GPU_TARGETS at the command line if desired
set(GPU_TARGETS "${AMDGPU_TARGETS}" CACHE STRING "GPU architectures to build for")

include(CheckLanguage)
include(CMakeDependentOption)
check_language(HIP)
cmake_dependent_option(USE_HIPCXX "Use CMake HIP language support" OFF CMAKE_HIP_COMPILER OFF)
if(USE_HIPCXX)
  enable_language(HIP)
else()
  find_package(HIP MODULE) # hip_add_library is only provided by the find module
  if(NOT HIP_FOUND)
    message("-- HIP not found. Compiling WITHOUT HIP support.")
  endif()
endif()

cmake_dependent_option(SUPPORT_HIP "Compile WITH HIP support" ON "USE_HIPCXX OR HIP_FOUND" OFF)

# HIP related library dependencies
if(SUPPORT_HIP)
  if( CMAKE_CXX_COMPILER_ID MATCHES "Clang" )
    find_package( hip REQUIRED CONFIG PATHS ${HIP_DIR} ${ROCM_PATH} /opt/rocm )
  endif( )
  find_package(rocblas REQUIRED)
  find_package(rocsparse REQUIRED)
  find_package(rocprim REQUIRED)
  find_package(rocrand REQUIRED)
endif()

if(BUILD_CODE_COVERAGE)
  add_compile_options(-fprofile-arcs -ftest-coverage)
  add_link_options(--coverage -lgcov)
endif()

if(BUILD_ADDRESS_SANITIZER)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -shared-libasan")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -shared-libasan")
    add_link_options(-fuse-ld=lld)
endif()


# Setup version
rocm_setup_version(VERSION "4.0.1")

if(BUILD_CLIENTS_SAMPLES OR BUILD_CLIENTS_BENCHMARKS OR BUILD_CLIENTS_TESTS)
  set( BUILD_CLIENTS ON )
  rocm_package_setup_component(clients)
  if(BUILD_CLIENTS_TESTS)
    rocm_package_setup_client_component(tests)
  endif()
  if(BUILD_CLIENTS_BENCHMARKS)
    rocm_package_setup_client_component(benchmarks)
  endif()
endif()

# rocALUTION library
add_subdirectory(src)

# Trigger client builds if selected
if(BUILD_CLIENTS)
  add_subdirectory(clients)
endif()

# Package specific CPACK vars
if(SUPPORT_HIP)
  if(BUILD_ADDRESS_SANITIZER)
    set(DEPENDS_HIP_RUNTIME "hip-runtime-amd-asan >= 4.5.0" )
  else()
    set(DEPENDS_HIP_RUNTIME "hip-runtime-amd >= 4.5.0" )
  endif()
  rocm_package_add_dependencies(DEPENDS "${DEPENDS_HIP_RUNTIME}" "rocsparse >= 1.12.10" "rocblas >= 2.22.0" "rocrand >= 2.1.0")
endif()

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")

if(WIN32)
  set(CPACK_SOURCE_GENERATOR "ZIP")
  set(CPACK_GENERATOR "ZIP")
  set(CMAKE_INSTALL_PREFIX "C:/hipSDK" CACHE PATH "Install path" FORCE)
  set(INSTALL_PREFIX "C:/hipSDK")
  set(CPACK_SET_DESTDIR OFF)
  set(CPACK_PACKAGE_INSTALL_DIRECTORY "C:/hipSDK")
  set(CPACK_PACKAGING_INSTALL_PREFIX "")
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY OFF)
else()
  if(NOT CPACK_PACKAGING_INSTALL_PREFIX)
    set(CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  endif()
endif()

set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "\${CPACK_PACKAGING_INSTALL_PREFIX}" )

# Package name
set(package_name rocalution)

set(ROCALUTION_CONFIG_DIR "\${CPACK_PACKAGING_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Path placed into ldconfig file")

rocm_create_package(
  NAME ${package_name}
  DESCRIPTION "ROCm library for sparse linear systems"
  MAINTAINER "rocALUTION Maintainer <rocalution-maintainer@amd.com>"
  LDCONFIG
  LDCONFIG_DIR ${ROCALUTION_CONFIG_DIR}
)

#
# ADDITIONAL TARGETS FOR CODE COVERAGE
#
if(BUILD_CODE_COVERAGE)
  #
  # > make coverage_cleanup (clean coverage related files.)
  # > make coverage GTEST_FILTER=<>
  # will run:
  #  > make coverage_analysis GTEST_FILTER=<> (analyze tests)
  #  > make coverage_output (generate html documentation)
  #

  #
  # Run coverage analysis
  #
  add_custom_target(coverage_analysis
    COMMAND echo Coverage GTEST_FILTER=\${GTEST_FILTER}
    COMMAND ./clients/staging/rocalution-test --gtest_filter=\"\${GTEST_FILTER}\"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

  add_dependencies(coverage_analysis rocalution)

  #
  # Prepare coverage output
  # This little script is generated because the option '--gcov-tool <program name>' of lcov cannot take arguments.
  #
  add_custom_target(coverage_output
    DEPENDS coverage_analysis
    COMMAND mkdir -p lcoverage
    )

  #
  # Generate coverage output.
  #
  add_custom_command(TARGET coverage_output
    COMMAND lcov --directory . --base-directory . --capture -o lcoverage/raw_main_coverage.info
    COMMAND lcov --remove lcoverage/raw_main_coverage.info "'${CMAKE_SOURCE_DIR}/src/utils/*'" "'${CMAKE_SOURCE_DIR}/src/base/host/host_io.*'" "'${CMAKE_SOURCE_DIR}/clients/*'" "'${CMAKE_SOURCE_DIR}/build/*'" "'/opt/*'" "'/usr/*'" -o lcoverage/main_coverage.info
    COMMAND genhtml lcoverage/main_coverage.info --output-directory lcoverage
    )

  add_custom_target(coverage DEPENDS coverage_output)

  #
  # Coverage cleanup
  #
  add_custom_target(coverage_cleanup
    COMMAND find ${CMAKE_BINARY_DIR} -name *.gcda -delete
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endif()

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# This option only works for make/nmake and the ninja generators, but no reason it shouldn't be on all the time
# This tells cmake to create a compile_commands.json file that can be used with clang tooling or vim
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Print verbose compiler flags
if(BUILD_VERBOSE)
  include(../cmake/Verbose.cmake)
endif()

# Configure a header file to pass the rocALUTION version
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/base/version.hpp.in"
               "${PROJECT_BINARY_DIR}/include/rocalution/version.hpp"
)

# Default integer types
if(BUILD_GLOBALTYPE_64)
  set(rocalution_GLOBAL_TYPE "int64_t")
else()
  set(rocalution_GLOBAL_TYPE "int32_t")
endif()

if(BUILD_LOCALTYPE_64)
  set(rocalution_LOCAL_TYPE "int64_t")
else()
  set(rocalution_LOCAL_TYPE "int32_t")
endif()

if(BUILD_PTRTYPE_64)
  set(rocalution_PTR_TYPE "int64_t")
else()
  set(rocalution_PTR_TYPE "int32_t")
endif()

# Configure a header file to specify rocALUTION indexing types
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/utils/types.hpp.in"
               "${PROJECT_BINARY_DIR}/include/rocalution/utils/types.hpp"
)

# Include sub-directories
include(base/CMakeLists.txt)
include(base/host/CMakeLists.txt)
include(solvers/CMakeLists.txt)
include(utils/CMakeLists.txt)

if(SUPPORT_HIP)
  include(base/hip/CMakeLists.txt)
endif()

# Public rocALUTION headers
set(PUBLIC_HEADERS
    rocalution.hpp
    ${BASE_PUBLIC_HEADERS}
    ${SOLVERS_PUBLIC_HEADERS}
    ${UTILS_PUBLIC_HEADERS}
)

# Copy public headers to include directory
foreach(i ${PUBLIC_HEADERS})
  configure_file("${i}" "${PROJECT_BINARY_DIR}/include/rocalution/${i}" COPYONLY)
endforeach()

source_group("Header Files\\Public" FILES ${PUBLIC_HEADERS})

# rocALUTION source
set(SOURCE
    ${BASE_SOURCES}
    ${HOST_SOURCES}
    ${SOLVERS_SOURCES}
    ${UTILS_SOURCES}
)

if(SUPPORT_MPI)
  list(APPEND SOURCE ${UTILS_MPI_SOURCES})
endif()

# Create rocALUTION host library
add_library(rocalution ${SOURCE} ${PUBLIC_HEADERS})
add_library(roc::rocalution ALIAS rocalution)

set(package_depends)
set(static_depends)

# Target link libraries
if(SUPPORT_OMP)
  if(CMAKE_VERSION VERSION_LESS "3.29.0"
      AND (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      AND (CMAKE_CXX_SIMULATE_ID STREQUAL "MSVC")
      AND (CMAKE_CXX_COMPILER_FRONTEND_VARIANT STREQUAL "GNU"))
    # Versions of CMake before 3.29.0 didn't correctly add the OpenMP library
    # to the OpenMP::OpenMP_CXX target when using LLVM Clang with GNU-compatible
    # front-end (i.e., `clang++`, not `clang-cl`) targeting the MSVC ABI.
    # Work around that issue by manually linking to libomp.
    target_link_libraries(rocalution PRIVATE OpenMP::OpenMP_CXX libomp)
  else()
    target_link_libraries(rocalution PRIVATE OpenMP::OpenMP_CXX)
  endif()
  list(APPEND package_depends PACKAGE OpenMP)
endif()

if(SUPPORT_MPI)
  target_link_libraries(rocalution PUBLIC MPI::MPI_CXX)
  list(APPEND static_depends PACKAGE MPI)
endif()

# Target compile definitions
if(SUPPORT_MPI)
  target_compile_definitions(rocalution PRIVATE SUPPORT_MULTINODE)
endif()

if(BUILD_SUPPORT_COMPLEX)
  target_compile_definitions(rocalution PRIVATE SUPPORT_COMPLEX)
endif()

if(SUPPORT_HIP)
  target_compile_definitions(rocalution PRIVATE SUPPORT_HIP)
  list(APPEND package_depends PACKAGE HIP)
endif()

# Target properties
rocm_set_soversion(rocalution "1.0")
set_target_properties(rocalution PROPERTIES DEBUG_POSTFIX "-d")
if(WIN32)
  set_target_properties(rocalution PROPERTIES CXX_VISIBILITY_PRESET "hidden" VISIBILITY_INLINES_HIDDEN ON)
endif()

# Generate export header
include(GenerateExportHeader)
generate_export_header(rocalution EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/rocalution/export.hpp)

# If CPU optimizations for local machine is actived
if(BUILD_OPTCPU)
  list(APPEND CMAKE_HOST_FLAGS "-march=native")
endif()

# Set compile options
list(APPEND CMAKE_HOST_FLAGS "-O3")
target_compile_options(rocalution PRIVATE ${CMAKE_HOST_FLAGS})

# Create rocALUTION hip library
if(SUPPORT_HIP)
  # Flag source file as a hip source file
  if(USE_HIPCXX)
    set_source_files_properties(${HIP_SOURCES} PROPERTIES LANGUAGE HIP)
  else()
    set_source_files_properties(${HIP_SOURCES} PROPERTIES HIP_SOURCE_PROPERTY_FORMAT TRUE)
  endif()

  if(USE_HIPCXX)
    add_library(rocalution_hip ${HIP_SOURCES})
    # If CPU optimizations for local machine is actived
    if(BUILD_OPTCPU)
      target_compile_options(rocalution_hip PRIVATE "-march=native")
    endif()
  else()
    # HIP flags workaround while target_compile_options do not work

    # If CPU optimizations for local machine is actived
    if(BUILD_OPTCPU)
      list(APPEND HIP_HIPCC_FLAGS "-march=native")
    endif()

    list(APPEND HIP_HIPCC_FLAGS "-O3 -fPIC -std=c++17")
    # Use -DNDEBUG compile option for Release and RelWithDebInfo build
    if((${CMAKE_BUILD_TYPE} MATCHES "Release") OR (${CMAKE_BUILD_TYPE} MATCHES "RelWithDebInfo"))
      list(APPEND HIP_HIPCC_FLAGS "-DNDEBUG")
    endif()
    foreach(target ${GPU_TARGETS})
      list(APPEND HIP_HIPCC_FLAGS "--offload-arch=${target}")
    endforeach()

    # Create rocALUTION HIP library
    if(WIN32)
      add_library(rocalution_hip OBJECT ${HIP_SOURCES})
    else()
      hip_add_library(rocalution_hip ${HIP_SOURCES})
    endif()
  endif()

  if(SUPPORT_MPI)
    target_compile_definitions(rocalution_hip PRIVATE SUPPORT_MULTINODE)
    target_link_libraries(rocalution_hip PUBLIC MPI::MPI_CXX)
  endif()

  if(BUILD_SUPPORT_COMPLEX)
    target_compile_definitions(rocalution_hip PRIVATE SUPPORT_COMPLEX)
  endif()

  rocm_set_soversion(rocalution_hip "1.0.0")
  set_target_properties(rocalution_hip PROPERTIES DEBUG_POSTFIX "-d")

  if(WIN32)
    target_link_libraries(rocalution_hip PRIVATE roc::rocblas roc::rocsparse roc::rocprim roc::rocrand hip::device)
  else()
    target_link_libraries(rocalution_hip PRIVATE roc::rocblas roc::rocsparse roc::rocprim roc::rocrand)
  endif()
  list(APPEND static_depends PACKAGE rocblas)
  list(APPEND static_depends PACKAGE rocsparse)
  list(APPEND static_depends PACKAGE rocprim)
  list(APPEND static_depends PACKAGE rocrand)

  target_link_libraries(rocalution PRIVATE rocalution_hip hip::host)
endif()

set_target_properties(rocalution PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")

if(WIN32 AND BUILD_CLIENTS AND BUILD_SHARED_LIBS)
  add_custom_command(TARGET rocalution POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/staging/$<TARGET_FILE_NAME:rocalution> ${PROJECT_BINARY_DIR}/clients/staging/$<TARGET_FILE_NAME:rocalution>)
  if( ${CMAKE_BUILD_TYPE} MATCHES "Debug")
    add_custom_command(TARGET rocalution POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/staging/rocalution.pdb ${PROJECT_BINARY_DIR}/clients/staging/rocalution.pdb )
  endif()
endif()

# Install targets
if(SUPPORT_HIP)
  rocm_install_targets(TARGETS rocalution rocalution_hip
                       INCLUDE ${CMAKE_BINARY_DIR}/include
                       )
else()
  rocm_install_targets(TARGETS rocalution
                       INCLUDE ${CMAKE_BINARY_DIR}/include
                       )
endif()

# Export targets
rocm_export_targets(TARGETS roc::rocalution
                    DEPENDS
                      ${package_depends}
                    STATIC_DEPENDS
                      ${static_depends}
                    NAMESPACE roc::)

=== clients/benchmarks/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2022-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

set(ROCALUTION_BENCHMARK_SOURCES
  client.cpp
  rocalution_arguments_config.cpp
  rocalution_bench.cpp
  rocalution_bench_solver_parameters.cpp
  rocalution_bench_solver_results.cpp
  rocalution_enum_coarsening_strategy.cpp
  rocalution_enum_directsolver.cpp
  rocalution_enum_itilu0_alg.cpp
  rocalution_enum_itsolver.cpp
  rocalution_enum_matrix_init.cpp
  rocalution_enum_preconditioner.cpp
  rocalution_enum_smoother.cpp
  rocalution_bench_cmdlines.cpp
  rocalution_bench_app.cpp
)

add_executable(rocalution-bench ${ROCALUTION_BENCHMARK_SOURCES} ${ROCALUTION_CLIENTS_COMMON})

# Target compile options
target_compile_options(rocalution-bench PRIVATE -Wall)

# Internal common header
target_include_directories(rocalution-bench PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

# Target link libraries
target_link_libraries(rocalution-bench PRIVATE roc::rocalution)

if(NOT TARGET rocalution)
  set_target_properties(rocalution-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")
else()
  set_target_properties(rocalution-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/clients/staging")
endif()

rocm_install(TARGETS rocalution-bench COMPONENT benchmarks)

=== clients/samples/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# Function to add rocalution examples
function(add_rocalution_example EXAMPLE_SOURCE)
  get_filename_component(EXAMPLE_TARGET ${EXAMPLE_SOURCE} NAME_WE)
  add_executable(${EXAMPLE_TARGET} ${EXAMPLE_SOURCE} ${ROCALUTION_CLIENTS_COMMON})

  # Include common client headers
  target_include_directories(${EXAMPLE_TARGET} PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

  # Link rocALUTION library
  target_link_libraries(${EXAMPLE_TARGET} PRIVATE roc::rocalution)

  if (BUILD_CODE_COVERAGE)
    target_link_libraries(${EXAMPLE_TARGET} PRIVATE -lgcov)
  endif()

  # Examples output directory
  if(NOT TARGET rocalution)
    set_target_properties(${EXAMPLE_TARGET} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")
  else()
    set_target_properties(${EXAMPLE_TARGET} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/clients/staging")
  endif()
endfunction()

# Examples
add_rocalution_example(amg.cpp)
add_rocalution_example(sa-amg.cpp)
add_rocalution_example(ua-amg.cpp)
add_rocalution_example(as-precond.cpp)
add_rocalution_example(async.cpp)
add_rocalution_example(benchmark.cpp)
add_rocalution_example(bicgstab.cpp)
add_rocalution_example(block-precond.cpp)
add_rocalution_example(cg-amg.cpp)
add_rocalution_example(cg-rsamg.cpp)
add_rocalution_example(cg-saamg.cpp)
add_rocalution_example(cg.cpp)
add_rocalution_example(cmk.cpp)
if(BUILD_SUPPORT_COMPLEX)
  add_rocalution_example(complex.cpp)
endif()
add_rocalution_example(direct.cpp)
add_rocalution_example(fcg.cpp)
add_rocalution_example(fixed-point.cpp)
add_rocalution_example(gmres.cpp)
add_rocalution_example(fgmres.cpp)
add_rocalution_example(idr.cpp)
add_rocalution_example(key.cpp)
add_rocalution_example(me-preconditioner.cpp)
add_rocalution_example(mixed-precision.cpp)
add_rocalution_example(power-method.cpp)
add_rocalution_example(simple-spmv.cpp)
add_rocalution_example(sp-precond.cpp)
add_rocalution_example(stencil.cpp)
add_rocalution_example(tns.cpp)
add_rocalution_example(var-precond.cpp)
add_rocalution_example(itsolve.cpp)

# MPI examples
if(SUPPORT_MPI)
  add_rocalution_example(benchmark_mpi.cpp)
  add_rocalution_example(bicgstab_mpi.cpp)
  add_rocalution_example(cg-amg_mpi.cpp)
  add_rocalution_example(cg-rsamg_mpi.cpp)
  add_rocalution_example(cg_mpi.cpp)
  add_rocalution_example(cg-saamg_mpi.cpp)
  add_rocalution_example(cg-uaamg_mpi.cpp)
  add_rocalution_example(fcg_mpi.cpp)
  add_rocalution_example(fgmres_mpi.cpp)
  add_rocalution_example(global-io_mpi.cpp)
  add_rocalution_example(idr_mpi.cpp)
  add_rocalution_example(qmrcgstab_mpi.cpp)
  add_rocalution_example(laplace_2d_weak_scaling.cpp)
  add_rocalution_example(laplace_3d_weak_scaling.cpp)
endif()

=== clients/tests/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2025 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# Find google test and its dependencies
find_package(GTest REQUIRED)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Non MPI tests
set(ROCALUTION_TEST_SOURCES
  rocalution_host_gtest_main.cpp
# Direct solvers
  test_qr.cpp
  test_lu.cpp
  test_inversion.cpp
# Krylov solvers
  test_backend.cpp
  test_bicgstab.cpp
  test_bicgstabl.cpp
  test_cg.cpp
  test_cr.cpp
  test_fcg.cpp
  test_fgmres.cpp
  test_gmres.cpp
  test_idr.cpp
  test_qmrcgstab.cpp
# AMG
  test_pairwise_amg.cpp
  test_ruge_stueben_amg.cpp
  test_saamg.cpp
  test_uaamg.cpp
# Other tests
  test_preconditioner.cpp
  test_itersolver.cpp
  test_chebyshev.cpp
  test_mixed_precision.cpp
)

if(NOT WIN32)
# Local structures - skip on Windows, as google test does not support union for death tests
list(APPEND ROCALUTION_TEST_SOURCES
    test_local_matrix.cpp
    test_local_matrix_multicoloring.cpp
    test_local_matrix_itsolve.cpp
    test_local_matrix_solve.cpp
    test_local_stencil.cpp
    test_local_vector.cpp
  )
endif()

# MPI tests
if(SUPPORT_MPI)
  list(APPEND ROCALUTION_TEST_SOURCES
    test_global_matrix.cpp
#    test_global_stencil.cpp
    test_global_vector.cpp
    test_parallel_manager.cpp
  )
endif()

# Common
list(APPEND ROCALUTION_TEST_SOURCES
  ../include/random.cpp
)

add_executable(rocalution-test ${ROCALUTION_TEST_SOURCES} ${ROCALUTION_CLIENTS_COMMON})

# Google test
target_compile_definitions(rocalution-test PRIVATE GOOGLE_TEST)
target_include_directories(rocalution-test SYSTEM PRIVATE $<BUILD_INTERFACE:${GTEST_INCLUDE_DIRS}>)
target_link_libraries(rocalution-test PRIVATE ${GTEST_BOTH_LIBRARIES} Threads::Threads)

# Include common client headers
target_include_directories(rocalution-test PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

# Link rocALUTION library
target_link_libraries(rocalution-test PRIVATE roc::rocalution)

if(NOT TARGET rocalution)
  set_target_properties(rocalution-test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")
else()
  set_target_properties(rocalution-test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/clients/staging")
endif()

# Add tests
add_test(rocalution-test rocalution-test)

rocm_install(TARGETS rocalution-test COMPONENT tests)

if (WIN32)
  # for now adding in all .dll as dependency chain is not cmake based on win32
  file( GLOB third_party_dlls
    LIST_DIRECTORIES OFF
    CONFIGURE_DEPENDS
    ${HIP_DIR}/bin/*.dll
    ${HIP_DIR}/bin/hipinfo.exe
    ${CMAKE_SOURCE_DIR}/rtest.*
    $ENV{rocsparse_DIR}/bin/*.dll
    $ENV{rocrand_DIR}/bin/*.dll
    $ENV{rocblas_DIR}/bin/*.dll
    C:/Windows/System32/libomp140*.dll
  )
  foreach( file_i ${third_party_dlls})
    add_custom_command( TARGET rocalution-test POST_BUILD COMMAND ${CMAKE_COMMAND} ARGS -E copy ${file_i} ${PROJECT_BINARY_DIR}/staging/ )
  endforeach( file_i )
endif()

=== docs/sphinx/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile requirements.in
#
accessible-pygments==0.0.5
    # via pydata-sphinx-theme
alabaster==0.7.16
    # via sphinx
asttokens==3.0.0
    # via stack-data
attrs==24.3.0
    # via
    #   jsonschema
    #   jupyter-cache
    #   referencing
babel==2.15.0
    # via
    #   pydata-sphinx-theme
    #   sphinx
beautifulsoup4==4.12.3
    # via pydata-sphinx-theme
breathe==4.35.0
    # via rocm-docs-core
certifi==2024.2.2
    # via requests
cffi==1.16.0
    # via
    #   cryptography
    #   pynacl
charset-normalizer==3.3.2
    # via requests
click==8.1.7
    # via
    #   jupyter-cache
    #   sphinx-external-toc
comm==0.2.2
    # via ipykernel
cryptography==42.0.7
    # via pyjwt
debugpy==1.8.12
    # via ipykernel
decorator==5.1.1
    # via ipython
deprecated==1.2.14
    # via pygithub
docutils==0.21.2
    # via
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx
exceptiongroup==1.2.2
    # via ipython
executing==2.1.0
    # via stack-data
fastjsonschema==2.19.1
    # via
    #   nbformat
    #   rocm-docs-core
gitdb==4.0.11
    # via gitpython
gitpython==3.1.43
    # via rocm-docs-core
greenlet==3.1.1
    # via sqlalchemy
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==8.6.1
    # via
    #   jupyter-cache
    #   myst-nb
ipykernel==6.29.5
    # via myst-nb
ipython==8.31.0
    # via
    #   ipykernel
    #   myst-nb
jedi==0.19.2
    # via ipython
jinja2==3.1.4
    # via
    #   myst-parser
    #   sphinx
jsonschema==4.23.0
    # via nbformat
jsonschema-specifications==2024.10.1
    # via jsonschema
jupyter-cache==1.0.1
    # via myst-nb
jupyter-client==8.6.3
    # via
    #   ipykernel
    #   nbclient
jupyter-core==5.7.2
    # via
    #   ipykernel
    #   jupyter-client
    #   nbclient
    #   nbformat
markdown-it-py==3.0.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.5
    # via jinja2
matplotlib-inline==0.1.7
    # via
    #   ipykernel
    #   ipython
mdit-py-plugins==0.4.1
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-nb==1.1.2
    # via rocm-docs-core
myst-parser==3.0.1
    # via myst-nb
nbclient==0.10.2
    # via
    #   jupyter-cache
    #   myst-nb
nbformat==5.10.4
    # via
    #   jupyter-cache
    #   myst-nb
    #   nbclient
nest-asyncio==1.6.0
    # via ipykernel
packaging==24.0
    # via
    #   ipykernel
    #   sphinx
parso==0.8.4
    # via jedi
pexpect==4.9.0
    # via ipython
platformdirs==4.3.6
    # via jupyter-core
prompt-toolkit==3.0.50
    # via ipython
psutil==6.1.1
    # via ipykernel
ptyprocess==0.7.0
    # via pexpect
pure-eval==0.2.3
    # via stack-data
pycparser==2.22
    # via cffi
pydata-sphinx-theme==0.16.1
    # via
    #   rocm-docs-core
    #   sphinx-book-theme
pygithub==2.3.0
    # via rocm-docs-core
pygments==2.18.0
    # via
    #   accessible-pygments
    #   ipython
    #   pydata-sphinx-theme
    #   sphinx
pyjwt[crypto]==2.8.0
    # via pygithub
pynacl==1.5.0
    # via pygithub
python-dateutil==2.9.0.post0
    # via jupyter-client
pyyaml==6.0.1
    # via
    #   jupyter-cache
    #   myst-nb
    #   myst-parser
    #   rocm-docs-core
    #   sphinx-external-toc
pyzmq==26.2.0
    # via
    #   ipykernel
    #   jupyter-client
referencing==0.36.1
    # via
    #   jsonschema
    #   jsonschema-specifications
requests==2.32.1
    # via
    #   pygithub
    #   sphinx
rocm-docs-core==1.21.1
    # via -r requirements.in
rpds-py==0.22.3
    # via
    #   jsonschema
    #   referencing
six==1.17.0
    # via python-dateutil
smmap==5.0.1
    # via gitdb
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.5
    # via beautifulsoup4
sphinx==7.3.7
    # via
    #   breathe
    #   myst-nb
    #   myst-parser
    #   pydata-sphinx-theme
    #   rocm-docs-core
    #   sphinx-book-theme
    #   sphinx-copybutton
    #   sphinx-design
    #   sphinx-external-toc
    #   sphinx-notfound-page
sphinx-book-theme==1.1.2
    # via rocm-docs-core
sphinx-copybutton==0.5.2
    # via rocm-docs-core
sphinx-design==0.5.0
    # via rocm-docs-core
sphinx-external-toc==1.0.1
    # via rocm-docs-core
sphinx-notfound-page==1.0.1
    # via rocm-docs-core
sphinxcontrib-applehelp==1.0.8
    # via sphinx
sphinxcontrib-devhelp==1.0.6
    # via sphinx
sphinxcontrib-htmlhelp==2.0.5
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.7
    # via sphinx
sphinxcontrib-serializinghtml==1.1.10
    # via sphinx
sqlalchemy==2.0.37
    # via jupyter-cache
stack-data==0.6.3
    # via ipython
tabulate==0.9.0
    # via jupyter-cache
tomli==2.0.1
    # via sphinx
tornado==6.4.2
    # via
    #   ipykernel
    #   jupyter-client
traitlets==5.14.3
    # via
    #   comm
    #   ipykernel
    #   ipython
    #   jupyter-client
    #   jupyter-core
    #   matplotlib-inline
    #   nbclient
    #   nbformat
typing-extensions==4.11.0
    # via
    #   ipython
    #   myst-nb
    #   pydata-sphinx-theme
    #   pygithub
    #   referencing
    #   sqlalchemy
urllib3==2.2.1
    # via
    #   pygithub
    #   requests
wcwidth==0.2.13
    # via prompt-toolkit
wrapt==1.16.0
    # via deprecated
zipp==3.21.0
    # via importlib-metadata

=== src/utils/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2024 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

set(UTILS_SOURCES
  utils/log.cpp
  utils/allocate_free.cpp
  utils/math_functions.cpp
  utils/time_functions.cpp
  utils/rocsparseio.cpp
)

set(UTILS_PUBLIC_HEADERS
  utils/def.hpp
  utils/allocate_free.hpp
  utils/time_functions.hpp
)

set(UTILS_MPI_SOURCES
  utils/communicator.cpp
)

=== src/base/hip/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

set(HIP_SOURCES
  base/hip/hip_conversion.cpp
  base/hip/hip_blas.cpp
  base/hip/hip_sparse.cpp
  base/hip/backend_hip.cpp
  base/hip/hip_allocate_free.cpp
  base/hip/hip_vector.cpp
  base/hip/hip_matrix_csr.cpp
  base/hip/hip_matrix_coo.cpp
  base/hip/hip_matrix_dense.cpp
  base/hip/hip_matrix_mcsr.cpp
  base/hip/hip_matrix_bcsr.cpp
  base/hip/hip_matrix_ell.cpp
  base/hip/hip_matrix_dia.cpp
  base/hip/hip_matrix_hyb.cpp
  base/hip/hip_rsamg_csr.cpp
)

=== src/base/host/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2024 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

set(HOST_SOURCES
  base/host/host_matrix_csr.cpp
  base/host/host_matrix_mcsr.cpp
  base/host/host_matrix_bcsr.cpp
  base/host/host_matrix_coo.cpp
  base/host/host_matrix_dia.cpp
  base/host/host_matrix_ell.cpp
  base/host/host_matrix_hyb.cpp
  base/host/host_matrix_dense.cpp
  base/host/host_vector.cpp
  base/host/host_conversion.cpp
  base/host/host_affinity.cpp
  base/host/host_io.cpp
  base/host/host_stencil_laplace2d.cpp
  base/host/host_sparse.cpp
  base/host/host_ilut_driver_csr.cpp
)

=== debian/changelog ===
rocalution (7.1.0-0ubuntu2) resolute; urgency=medium

  * d/shlibs: update SONAME version
  * d/rules: skip local_vector_test.extract_coarse_mapping_int on arm64
  * d/rules: fix execute_after_dh_auto_build-indep envvars

 -- Bruno Bernardo de Moura <bruno.moura@canonical.com>  Tue, 03 Feb 2026 16:40:38 -0300

rocalution (7.1.0-0ubuntu1) resolute; urgency=medium

  * New upstream release 7.1.0.
  * d/p/series: drop outdated and unused patches for 7.1.0
    - drop d/p/spelling.patch
    - drop d/p/use-readthedocs-theme.patch
    - drop d/p/docs-table-of-contents.patch
    - drop d/p/use-local-mathjax.patch.
    - drop d/p/fix-host-and-backend-function-documentation.patch
  * d/control: update standards version to 4.7.2
  * d/control: update maintainer field for ubuntu archive
  * d/control: update build-depends for rocm stack
  * d/control: update SOVERSION (0 -> 1) after API changes
  * d/rules: fix docs build step with rocm-docs-build
  * d/rules: fix lintian warnings and improve docs cleanup
  * d/{librocalution-doc.doc-base,librocalution-doc.docs}:
    fix doc generation paths
  * d/shlibs: drop auto generated file
  * d/{t/control,librocalution0-tests.install}:
    update test files SOVERSION (0 -> 1)
  * d/librocalution1.symbols: add symbols file for 7.1.0

 -- Bruno Bernardo de Moura <bruno.moura@canonical.com>  Wed, 10 Dec 2025 14:27:06 -0300

rocalution (5.7.1-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 29 Jan 2026 21:42:09 +0100

=== debian/control ===
Source: rocalution
Section: devel
Homepage: https://github.com/ROCm/rocALUTION
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocalution.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocalution
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.26.4-3),
               rocm-cmake,
               libomp-dev (>= 1.13.0),
               mpi-default-dev,
               libgtest-dev,
               pkg-rocm-tools
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               doxygen <!nodoc>,
               python3-doxysphinx <!nodoc>,
               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
               python3-sphinx-external-toc <!nodoc>,
               texlive-bibtex-extra,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: librocalution1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for iterative sparse solvers - library
 rocALUTION is a library that provides iterative sparse preconditioners and
 solvers. The rocALUTION project began as a port of PARALUTION to the AMD ROCm
 platform. This library supports an OpenMP backend for multi-core CPUs and an
 MPI backend for multi-node clusters.
 .
 rocALUTION provides a C++ API containing implementations of fixed-point
 iteration schemes such as Jacobi iteration and Gauss-Seidel; Krylov subspace
 methods such as the conjugate gradient method and the biconjugate gradient
 stabilized method; a mixed-precision defect correction scheme; a Chebyshev
 iteration scheme; as well as geometric and algebraic multigrid solvers. There
 are also a wide variety of sparse preconditioners, including several based on
 matrix splitting schemes, factorization schemes, and approximate inverses.
 .
 This package provides the AMD ROCm rocALUTION library.

Package: librocalution-dev
Section: libdevel
Architecture: any
Depends: librocalution1 (= ${binary:Version}),${misc:Depends},
Description: ROCm library for iterative sparse solvers - headers
 rocALUTION is a library that provides iterative sparse preconditioners and
 solvers. The rocALUTION project began as a port of PARALUTION to the AMD ROCm
 platform. This library supports an OpenMP backend for multi-core CPUs and an
 MPI backend for multi-node clusters.
 .
 rocALUTION provides a C++ API containing implementations of fixed-point
 iteration schemes such as Jacobi iteration and Gauss-Seidel; Krylov subspace
 methods such as the conjugate gradient method and the biconjugate gradient
 stabilized method; a mixed-precision defect correction scheme; a Chebyshev
 iteration scheme; as well as geometric and algebraic multigrid solvers. There
 are also a wide variety of sparse preconditioners, including several based on
 matrix splitting schemes, factorization schemes, and approximate inverses.
 .
 This package provides the AMD ROCm rocALUTION development headers.

Package: librocalution1-tests
Section: libdevel
Architecture: any
Depends: librocalution1 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for iterative sparse solvers - tests
 rocALUTION is a library that provides iterative sparse preconditioners and
 solvers. The rocALUTION project began as a port of PARALUTION to the AMD ROCm
 platform. This library supports an OpenMP backend for multi-core CPUs and an
 MPI backend for multi-node clusters.
 .
 rocALUTION provides a C++ API containing implementations of fixed-point
 iteration schemes such as Jacobi iteration and Gauss-Seidel; Krylov subspace
 methods such as the conjugate gradient method and the biconjugate gradient
 stabilized method; a mixed-precision defect correction scheme; a Chebyshev
 iteration scheme; as well as geometric and algebraic multigrid solvers. There
 are also a wide variety of sparse preconditioners, including several based on
 matrix splitting schemes, factorization schemes, and approximate inverses.
 .
 This package provides the AMD ROCm rocALUTION test binaries used for verifying
 that the library is functioning correctly.

Package: librocalution-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Built-Using: ${sphinxdoc:Built-Using}
Description: ROCm library for iterative sparse solvers - documentation
 rocALUTION is a library that provides iterative sparse preconditioners and
 solvers. The rocALUTION project began as a port of PARALUTION to the AMD ROCm
 platform. This library supports an OpenMP backend for multi-core CPUs and an
 MPI backend for multi-node clusters.
 .
 rocALUTION provides a C++ API containing implementations of fixed-point
 iteration schemes such as Jacobi iteration and Gauss-Seidel; Krylov subspace
 methods such as the conjugate gradient method and the biconjugate gradient
 stabilized method; a mixed-precision defect correction scheme; a Chebyshev
 iteration scheme; as well as geometric and algebraic multigrid solvers. There
 are also a wide variety of sparse preconditioners, including several based on
 matrix splitting schemes, factorization schemes, and approximate inverses.
 .
 This package provides the AMD ROCm rocALUTION documentation.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export VERBOSE=1

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DBUILD_CLIENTS_TESTS=ON \
	-DSUPPORT_HIP=OFF

%:
	dh $@ -Scmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

# Initially empty test filter; to be fullfiled as needed for the build architecture.
GTEST_FILTER_VAL := *

# On ARM64, the test local_vector_test.extract_coarse_mapping_int causes
# a segmentation fault, triggering a SIGSEGV in the extract_coarse_mapping
# function as described in (https://github.com/ROCm/rocALUTION/issues/322).
# Since different compilers handle memory allocation differently from one
# another, the test is being skipped to allow for successfull builds
# on those ARM plaforms.
ifeq ($(DEB_HOST_ARCH),arm64)
    GTEST_FILTER_VAL := *:-local_vector_test.extract_coarse_mapping_int
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Run tests applying the defined filter.
	export GTEST_FILTER="$(GTEST_FILTER_VAL)" && \
		obj-$(DEB_HOST_GNU_TYPE)/clients/staging/rocalution-test
endif

override_dh_auto_configure-indep:
	:

execute_after_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	perl -pi -e 's/WARN_AS_ERROR.*=.*YES/WARN_AS_ERROR = NO/' docs/doxygen/Doxyfile
	http_proxy='127.0.0.1:9' \
	https_proxy='127.0.0.1:9' \
	rocm-docs-build
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

override_dh_sphinxdoc:
	dh_sphinxdoc
	# Since dh_sphinxdoc depends on the redundant license file it should be removed only
	# after the execution of the rule.
	find debian/librocalution-doc -name "*license.rst*" -delete || true
	# Delete the unused .doctree file.
	find debian/librocalution-doc -name "*.doctree*" -delete || true
	# Delete unused fonts.
	rm -rf debian/librocalution-doc/usr/share/doc/*/html/_static/fonts/ || true
	rm -rf debian/librocalution-doc/usr/share/doc/*/html/_static/vendor/fontawesome/webfonts/ || true
	# Fix Privacy Breach (MathJax) by using local references instead of embedded js scripts.
	find debian/librocalution-doc/usr/share/doc -name "*.html" -exec \
		sed -i 's|https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js|/usr/share/javascript/mathjax/tex-mml-chtml.js|g' {} + || true

override_dh_makeshlibs:
	dh_makeshlibs -V -plibrocalution1 -- -c4

=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocalution1-tests
Depends: librocalution1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
